.const
CWUD                equ     CW_USEDEFAULT

BaseIdentifier      equ             101    
NoToolbarBitmaps    equ             16
cbMII               equ             sizeof MENUITEMINFO

NoTbFileButtons equ             11
NoTbViewButtons equ             9

TbFileId        equ             1000h
TbViewId        equ             1001
ReBarId         equ             1002h
TooltipsId      equ             1003h

NoMenuItems         equ     5
NoMenuFileItems     equ     12
IDM_NEW             equ     100h
IDM_OPEN            equ     101h
IDM_SAVE            equ     102h
IDM_SAVEAS          equ     103h
IDM_CLOSE           equ     104h
IDM_EXPORT          equ     105h
IDM_PRINT           equ     106h
IDM_PAGESETUP       equ     107h
IDM_EXIT            equ     108h
NoMenuEditItems     equ     10
IDM_BATCH           equ     200h
IDM_UNDO            equ     201h
IDM_REDO            equ     202h
IDM_CUT             equ     203h
IDM_COPY            equ     204h
IDM_PASTE           equ     205h
IDM_SELECT          equ     206h
IDM_SELECTALL       equ     207h
NoMenuViewItems     equ     9
IDM_TILEHORZ        equ     300h
IDM_TILEVERT        equ     301h
IDM_CASCADE	        equ     302h
IDM_ARRANGE         equ     303h
IDM_NEXT            equ     304h
IDM_PREV            equ     305h
IDM_FULLSCREEN      equ     306h
IDM_GOPTIONS        equ     400h
NoMenuHelpItems     equ     4
IDM_CONTENTS        equ     500h
IDM_COPYRIGHTS      equ     501h
IDM_LEGAL           equ     502h
IDM_ABOUT           equ     503h

NoTbFileTips        equ     9
NoTbViewTips        equ     7
.data

; ++++ Menu related ++++

hMenu           HMENU           ?
hMenuFile       HMENU           ?
hMenuNew        HMENU           ?
hMenuExport     HMENU           ?
hMenuView       HMENU	        ?
hMenuOptions    HMENU           ?
hMenuHelp       HMENU           ?

MenuMII         MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_SUBMENU,MFT_STRING,0,\
                                0,?,0,0,0,offset szFile,sizeof szFile>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_SUBMENU,MFT_STRING,0,\
                                0,?,0,0,0,offset szEdit,sizeof szEdit>                                
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_SUBMENU,MFT_STRING,0,\
                                0,?,0,0,0,offset szView,sizeof szView>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_SUBMENU,MFT_STRING,0,\
                                0,?,0,0,0,offset szOptions,sizeof szOptions>
                MENUITEMINFO	  <cbMII,MIIM_TYPE+MIIM_SUBMENU,MFT_STRING,0,\
                                0,?,0,0,0,offset szHelp,sizeof szHelp>
                                                                                                
UCSTR           szFile,"File",0
UCSTR           szEdit,"Edit",0 
UCSTR           szView,"View",0
UCSTR           szOptions,"Options",0
UCSTR           szHelp,"Help",0
                               
MenuFileMII     MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_SUBMENU+MIIM_CHECKMARKS,\
                                MFT_STRING,0,IDM_NEW,?,?,?,0,offset szNew,sizeof szNew>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,\
                                MFT_STRING,0,IDM_OPEN,?,?,?,0,offset szOpen,sizeof szOpen>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,\
                                MFT_STRING,0,IDM_SAVE,?,?,?,0,offset szSave,sizeof szSave>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,\        
                                MFT_STRING,0,IDM_SAVEAS,?,?,?,0,offset szSaveAs,sizeof szSaveAs>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,\
                                MFT_STRING,0,IDM_CLOSE,?,?,?,0,offset szClose,sizeof szClose>
                MENUITEMINFO    <cbMII,MIIM_TYPE,MFT_SEPARATOR,\
                                0,0,0,0,0,0,0,0>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_SUBMENU+MIIM_CHECKMARKS,\
                                MFT_STRING,0,IDM_EXPORT,?,?,?,0,offset szExport,sizeof szExport>
                MENUITEMINFO    <cbMII,MIIM_TYPE,MFT_SEPARATOR,\
                                0,0,0,0,0,0,0,0>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,\
                                MFT_STRING,0,IDM_PRINT,0,?,?,0,offset szPrint,sizeof szPrint>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,\
                                MFT_STRING,0,IDM_PAGESETUP,0,?,?,0,offset szPageSetup,sizeof szPageSetup>
                MENUITEMINFO    <cbMII,MIIM_TYPE,MFT_SEPARATOR,\
                                0,0,0,0,0,0,0,0>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,\
                                MFT_STRING,0,IDM_EXIT,0,?,?,0,offset szExit,sizeof szExit>
UCSTR           szNew,"New",0
UCSTR           szOpen,"Open",0
UCSTR           szSave,"Save",0
UCSTR           szSaveAs,"Save As",0
UCSTR           szClose,"Close",0
UCSTR           szExport,"Export",0
UCSTR           szPrint,"Print",0
UCSTR           szPageSetup,"Page Setup",0
UCSTR           szExit,"Exit",0

MenuFileBmpIds  dd              101,103,105,129,125,0,119,0,121,123,0,127

hMenuEdit       HMENU           ?
hMenuBatch      HMENU           ?

MenuEditMII     MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_SUBMENU+MIIM_CHECKMARKS,\
                                MFT_STRING,0,IDM_BATCH,?,?,?,0,offset szBatch,sizeof szBatch>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,\
                                MFT_STRING,0,IDM_UNDO,0,?,?,0,offset szUndo,sizeof szUndo>
                MENUITEMINFO	  <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,\
                                MFT_STRING,0,IDM_REDO,0,?,?,0,offset szRedo,sizeof szRedo>
                MENUITEMINFO    <cbMII,MIIM_TYPE,MFT_SEPARATOR,\
                                0,0,0,0,0,0,0,0>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,\
                                MFT_STRING,0,IDM_CUT,0,?,?,0,offset szCut,sizeof szCut>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,\
                                MFT_STRING,0,IDM_COPY,0,?,?,0,offset szCopy,sizeof szCopy>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,\
                                MFT_STRING,0,IDM_PASTE,0,?,?,0,offset szPaste,sizeof szPaste>                                
                MENUITEMINFO    <cbMII,MIIM_TYPE,MFT_SEPARATOR,\
                                0,0,0,0,0,0,0,0>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,\
                                MFT_STRING,0,IDM_SELECT,0,?,?,0,offset szSelect,sizeof szSelect>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,\
                                MFT_STRING,0,IDM_SELECTALL,0,?,?,0,offset szSelectAll,sizeof szSelectAll>
UCSTR           szBatch,"Batch",0         
UCSTR           szUndo,"Undo",0
UCSTR           szRedo,"Redo",0
UCSTR           szCut,"Cut",0
UCSTR           szCopy,"Copy",0
UCSTR           szPaste,"Paste",0
UCSTR           szSelect,"Select Current",0
UCSTR           szSelectAll,"Select All",0

MenuEditBmpIds  dd          131,109,111,0,113,115,117,0,133,135

MenuViewMII     MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,MFT_STRING,0,IDM_TILEHORZ,\
                                0,?,?,0,offset szTileHorz,sizeof szTileHorz>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,MFT_STRING,0,IDM_TILEVERT,\
                                0,?,?,0,offset szTileVert,sizeof szTileVert>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,MFT_STRING,0,IDM_CASCADE,\
                                0,?,?,0,offset szCascade,sizeof szCascade>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,MFT_STRING,0,IDM_ARRANGE,\
                                0,?,?,0,offset szArrange,sizeof szArrange>
                MENUITEMINFO    <cbMII,MIIM_TYPE,MFT_SEPARATOR,0,0,0,0,0,0,0,0>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,MFT_STRING,0,IDM_PREV,\
                                0,?,?,0,offset szPrevious,sizeof szPrevious>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,MFT_STRING,0,IDM_NEXT,\
                                0,?,?,0,offset szNext,sizeof szNext>
                MENUITEMINFO    <cbMII,MIIM_TYPE,MFT_SEPARATOR,0,0,0,0,0,0,0,0>                                
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,MFT_STRING,0,IDM_FULLSCREEN,\
                                0,?,?,0,offset szFullScreen,sizeof szFullScreen>

UCSTR           szTileHorz,"Tile Horizontal",0
UCSTR           szTileVert,"Tile Vertical",0
UCSTR           szCascade,"Cascade",0
UCSTR           szArrange,"Icon Arrange",0
UCSTR           szNext,"Next Window",0
UCSTR           szPrevious,"Previous Window",0
UCSTR           szFullScreen,"Full Screen",0

MenuViewBmpIds  dd              137,139,141,143,0,147,145,0,149

MenuOptionsMII  MENUITEMINFO	   <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,MFT_STRING,0,\
                                IDM_GOPTIONS,0,?,?,0,offset szGeneralOptions,sizeof szGeneralOptions>
UCSTR           szGeneralOptions,"General Options",0                                
MenuOptionsBmpId        equ     157

MenuHelpMII     MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,MFT_STRING,0,\
                                IDM_CONTENTS,0,?,?,0,offset szContents,sizeof szContents>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,MFT_STRING,0,\
                                IDM_COPYRIGHTS,0,?,?,0,offset szCopyrights,sizeof szCopyrights>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,MFT_STRING,0,\
                                IDM_LEGAL,0,?,?,0,offset szLegalNotices,sizeof szLegalNotices>
                MENUITEMINFO    <cbMII,MIIM_TYPE+MIIM_ID+MIIM_CHECKMARKS,MFT_STRING,0,\
                                IDM_ABOUT,0,?,?,0,offset szAbout,sizeof szAbout>
UCSTR           szContents,"Contents",0
UCSTR           szCopyrights,"Copyrights",0
UCSTR           szLegalNotices,"Legal Notices",0
UCSTR           szAbout,"About",0
MenuHelpBmpIds  dd              151,153,155,101                                                                                                                                                                                                                 
; ++++ Rebar related ++++

hReBar          HWND            ?
UCSTR           ReBarClass,"ReBarWindow32",0
rbbi            REBARBANDINFO   <sizeof rbbi,RBBIM_CHILD+RBBIM_CHILDSIZE+RBBIM_ID+RBBIM_SIZE+RBBIM_STYLE,\
                                RBBS_GRIPPERALWAYS,<>>
clrScheme       COLORSCHEME     <sizeof COLORSCHEME,080h,040h>
; ++++ Toolbar related ++++

hTbFile         HWND            ?
UCSTR           ToolbarClass,"ToolbarWindow32",0
TbFileButtons   TBBUTTON        <0,IDM_NEW,TBSTATE_ENABLED,BTNS_BUTTON,0,0>
                TBBUTTON	  <1,IDM_OPEN,TBSTATE_ENABLED,BTNS_BUTTON,0,0>
                TBBUTTON        <2,IDM_SAVE,TBSTATE_ENABLED,BTNS_BUTTON,0,0>
                TBBUTTON        <3,IDM_EXPORT,TBSTATE_ENABLED,BTNS_BUTTON,0,0>
                TBBUTTON	  <6,0,0,BTNS_SEP,0,0>
                TBBUTTON        <4,IDM_UNDO,TBSTATE_ENABLED,BTNS_BUTTON,0,0>
                TBBUTTON        <5,IDM_REDO,TBSTATE_ENABLED,BTNS_BUTTON,0,0>
                TBBUTTON        <6,0,0,BTNS_SEP,0,0>
                TBBUTTON        <6,IDM_CUT,TBSTATE_ENABLED,BTNS_BUTTON,0,0>
                TBBUTTON        <7,IDM_COPY,TBSTATE_ENABLED,BTNS_BUTTON,0,0>
                TBBUTTON        <8,IDM_PASTE,TBSTATE_ENABLED,BTNS_BUTTON,0,0>
hTbView         HWND            ?
TbViewButtons   TBBUTTON        <9,IDM_TILEHORZ,TBSTATE_ENABLED,BTNS_BUTTON,0,0>        
                TBBUTTON        <10,IDM_TILEVERT,TBSTATE_ENABLED,BTNS_BUTTON,0,0>
                TBBUTTON        <11,IDM_CASCADE,TBSTATE_ENABLED,BTNS_BUTTON,0,0>
                TBBUTTON	  <12,IDM_ARRANGE,TBSTATE_ENABLED,BTNS_BUTTON,0,0>
                TBBUTTON	  <6,0,0,BTNS_SEP,0,0>
                TBBUTTON        <14,IDM_PREV,TBSTATE_ENABLED,BTNS_BUTTON,0,0>
                TBBUTTON        <13,IDM_NEXT,TBSTATE_ENABLED,BTNS_BUTTON,0,0>
                TBBUTTON	  <6,0,0,BTNS_SEP,0,0>
                TBBUTTON        <15,IDM_FULLSCREEN,TBSTATE_ENABLED,BTNS_BUTTON,0,0>

ToolbarBmpIdentifiers           dd      101,103,105,107,109,111,113,115,117
                                dd      137,139,141,143,145,147,149
                                
; ++++ Tooltips related ++++

hTooltips       HWND            ?
UCSTR           TooltipsClass,"tooltips_class32",0
ti              TOOLINFO        <sizeof ti,TTF_CENTERTIP,0,0,<?>,0,0>
FileStringsOffsets      dd              offset szNew,IDM_NEW
                        dd              offset szOpen,IDM_OPEN
                        dd              offset szSave,IDM_SAVE
                        dd              offset szExport,IDM_EXPORT
                        dd              offset szUndo,IDM_UNDO
                        dd              offset szRedo,IDM_REDO
                        dd              offset szCut,IDM_CUT
                        dd              offset szCopy,IDM_COPY
                        dd              offset szPaste,IDM_PASTE
                        
ViewStringsOffsets      dd              offset szTileHorz,IDM_TILEHORZ
                        dd              offset szTileVert,IDM_TILEVERT
                        dd              offset szCascade,IDM_CASCADE
                        dd              offset szArrange,IDM_ARRANGE
                        dd              offset szNext,IDM_NEXT
                        dd              offset szPrevious,IDM_PREV
                        dd              offset szFullScreen,IDM_FULLSCREEN

; ++++ MDI Related ++++

hMDIClient              HWND            ?
UCSTR               	MDIClientClass,"MDICLIENT",0
ccs                     CLIENTCREATESTRUCT <?,1000h>
                                                
; ++++ Other Vars ++++

hIml            dd              ?

.code
CreateMenus PROC    hWnd:DWORD

    invoke  CreateMenu
    mov     hMenu,eax
    invoke  SetMenu,hWnd,eax
    invoke  CreatePopupMenu
    mov     hMenuFile,eax
    invoke  CreatePopupMenu
    mov     hMenuNew,eax
    invoke  CreatePopupMenu
    mov     hMenuExport,eax
    invoke  CreatePopupMenu
    mov     hMenuEdit,eax
    invoke  CreatePopupMenu
    mov     hMenuBatch,eax
    invoke  CreatePopupMenu
    mov     hMenuView,eax
    invoke  CreatePopupMenu
    mov     hMenuOptions,eax
    invoke  CreatePopupMenu
    mov     hMenuHelp,eax
    lea     edi,MenuMII
    assume  edi:PTR MENUITEMINFO
    mov     ecx,NoMenuItems
loop_0:
    push    ecx    
    .if     ecx==5
        push    hMenuFile
        pop     [edi].hSubMenu
    .elseif     ecx==4
        push    hMenuEdit
        pop     [edi].hSubMenu
    .elseif ecx==3
        push    hMenuView
        pop     [edi].hSubMenu   
    .elseif ecx==2
        push    hMenuOptions
        pop     [edi].hSubMenu
    .elseif ecx==1
        push    hMenuHelp
        pop     [edi].hSubMenu                
    .endif                        
    invoke  InsertMenuItem,hMenu,-1,TRUE,edi
    add     edi,cbMII
    pop     ecx
    dec     ecx
    jcxz    end_loop_0
    jmp     loop_0
end_loop_0:    
    lea     edi,MenuFileMII
    lea     esi,MenuFileBmpIds
    mov     ecx,NoMenuFileItems
    cld
loop_1:                
    push    ecx
    .if     ecx==12
        push    hMenuNew
        pop     [edi].hSubMenu
    .elseif ecx==6
        push    hMenuExport
        pop     [edi].hSubMenu
    .endif
    lodsd        
    or      eax,eax
    jz      no_bitmap
    invoke  LoadImage,hInstance,eax,IMAGE_BITMAP,20,20,LR_LOADMAP3DCOLORS+LR_LOADTRANSPARENT
    mov     [edi].hbmpChecked,eax
    mov     [edi].hbmpUnchecked,eax      
no_bitmap:    
    push    eax
    invoke  InsertMenuItem,hMenuFile,-1,TRUE,edi
    pop     eax
    add     edi,cbMII
    pop     ecx
    dec     ecx
    jcxz    end_loop_1
    jmp     loop_1
end_loop_1:
    lea     edi,MenuEditMII
    lea     esi,MenuEditBmpIds
    mov     ecx,NoMenuEditItems
    cld
loop_2:
    push    ecx
    .if     ecx==9
        push    hMenuBatch
        pop     [edi].hSubMenu
    .endif
    lodsd
    invoke  LoadImage,hInstance,eax,IMAGE_BITMAP,20,20,LR_LOADMAP3DCOLORS+LR_LOADTRANSPARENT
    mov     [edi].hbmpChecked,eax
    mov     [edi].hbmpUnchecked,eax
    invoke  InsertMenuItem,hMenuEdit,-1,TRUE,edi
    add     edi,cbMII
    pop     ecx
    dec     ecx
    jcxz    end_loop_2
    jmp     loop_2
end_loop_2:                
    lea     edi,MenuViewMII
    lea     esi,MenuViewBmpIds
    mov     ecx,NoMenuViewItems
    cld
loop_3:    
    push    ecx
    lodsd
    invoke  LoadImage,hInstance,eax,IMAGE_BITMAP,20,20,LR_LOADMAP3DCOLORS+LR_LOADTRANSPARENT
    mov     [edi].hbmpChecked,eax
    mov     [edi].hbmpUnchecked,eax
    invoke  InsertMenuItem,hMenuView,-1,TRUE,edi
    add     edi,cbMII
    pop     ecx
    dec     ecx
    jcxz    end_loop_3       
    jmp     loop_3
end_loop_3:
    invoke  LoadImage,hInstance,MenuOptionsBmpId,IMAGE_BITMAP,20,20,\
                LR_LOADMAP3DCOLORS+LR_LOADTRANSPARENT
    mov     MenuOptionsMII.hbmpChecked,eax
    mov     MenuOptionsMII.hbmpUnchecked,eax                   
    invoke  InsertMenuItem,hMenuOptions,-1,TRUE,addr MenuOptionsMII
    lea     edi,MenuHelpMII
    lea     esi,MenuHelpBmpIds
    mov     ecx,NoMenuHelpItems
loop_4:
    lodsd
    push    ecx
    invoke  LoadImage,hInstance,eax,IMAGE_BITMAP,20,20,LR_LOADMAP3DCOLORS+LR_LOADTRANSPARENT            
    mov     [edi].hbmpChecked,eax
    mov     [edi].hbmpUnchecked,eax
    invoke  InsertMenuItem,hMenuHelp,-1,TRUE,edi
    add     edi,cbMII
    pop     ecx
    dec     ecx
    jcxz    end_loop_4
    jmp     loop_4
end_loop_4:    
    invoke  DrawMenuBar,hWnd
    ret
                                          
CreateMenus endp

CreateControls  PROC    hWnd:DWORD

    invoke  CreateWindowEx,0,addr ReBarClass,0,WS_VISIBLE+WS_CHILD+RBS_AUTOSIZE+CCS_NODIVIDER,\
                CWUD,CWUD,CWUD,CWUD,hWnd,ReBarId,hInstance,0
    mov     hReBar,eax
    invoke  SendMessage,eax,RB_SETCOLORSCHEME,0,addr clrScheme
    invoke  SendMessage,hReBar,RB_SETBKCOLOR,0,08000h
    invoke  CreateWindowEx,0,addr ToolbarClass,0,WS_VISIBLE+WS_CHILD+TBSTYLE_FLAT+CCS_NOPARENTALIGN+CCS_NODIVIDER,\
                CWUD,CWUD,CWUD,CWUD,hWnd,TbFileId,hInstance,0
    mov     hTbFile,eax
    mov     rbbi.hwndChild,eax
    invoke  SendMessage,hTbFile,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,0
    call    CreateImageList
    invoke  SendMessage,hTbFile,TB_SETIMAGELIST,0,hIml
    invoke  SendMessage,hTbFile,TB_ADDBUTTONS,NoTbFileButtons,addr TbFileButtons
    invoke  CreateWindowEx,WS_EX_TOOLWINDOW,addr TooltipsClass,0,WS_POPUP+WS_VISIBLE+WS_CHILD+TTS_ALWAYSTIP,\
                            CWUD,CWUD,CWUD,CWUD,hWnd,0,hInstance,0
    mov     hTooltips,eax
    invoke  SendMessage,hTbFile,TB_SETTOOLTIPS,hTooltips,0
    push    hInstance
    pop     ti.hInst
    push    hTbFile
    pop     ti.hWnd             
    lea     esi,FileStringsOffsets
    mov     ecx,NoTbFileTips
    cld
loop_1:
    lodsd                           
    mov     ti.lpszText,eax
    lodsd
    push    ecx    
    invoke  SendMessage,hTbFile,TB_COMMANDTOINDEX,eax,0
    invoke  SendMessage,hTbFile,TB_GETITEMRECT,eax,addr ti.rect
    invoke  SendMessage,hTooltips,TTM_ADDTOOL,0,addr ti
    inc     ti.uId  
    pop     ecx
    dec     ecx
    jcxz    end_loop_1
    jmp     loop_1
end_loop_1:    
    mov     rbbi.wID,TbFileId                                   
    mov     rbbi.lx,340
    mov     rbbi.cxMinChild,340
    mov     rbbi.cyMinChild,38
    invoke  SendMessage,hReBar,RB_INSERTBAND,-1,addr rbbi
    invoke  CreateWindowEx,0,addr ToolbarClass,0,WS_VISIBLE+WS_CHILD+TBSTYLE_FLAT+CCS_NOPARENTALIGN+CCS_NODIVIDER,\
                CWUD,CWUD,CWUD,CWUD,hWnd,TbViewId,hInstance,0
    mov     hTbView,eax        
    mov     rbbi.hwndChild,eax
    mov     rbbi.wID,TbViewId
    invoke  SendMessage,hTbView,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,0
    invoke  SendMessage,hTbView,TB_SETIMAGELIST,0,hIml
    invoke  SendMessage,hTbView,TB_ADDBUTTONS,NoTbViewButtons,addr TbViewButtons
    invoke  SendMessage,hTbView,TB_SETTOOLTIPS,hTooltips,0
    invoke  SendMessage,hReBar,RB_SETTOOLTIPS,hTooltips,0   
    push    hTbView
    pop     ti.hWnd
    lea     esi,ViewStringsOffsets
    mov     ecx,NoTbViewTips
loop_2:
    lodsd
    mov     ti.lpszText,eax
    lodsd
    push    ecx
    invoke  SendMessage,hTbView,TB_COMMANDTOINDEX,eax,0
    invoke  SendMessage,hTbView,TB_GETITEMRECT,eax,addr ti.rect
    invoke  SendMessage,hTooltips,TTM_ADDTOOL,0,addr ti
    inc     ti.uId
    pop     ecx
    dec     ecx
    jcxz    end_loop_2
    jmp     loop_2
end_loop_2:        
    mov     rbbi.lx,270
    mov     rbbi.cxMinChild,270
    mov     rbbi.cyMinChild,38
    invoke  SendMessage,hReBar,RB_INSERTBAND,-1,addr rbbi
    invoke  GetClientRect,hWnd,addr rect
    invoke  SendMessage,hReBar,RB_GETBARHEIGHT,0,0
    mov     rect.top,eax
    sub     rect.bottom,eax
    invoke  CreateWindowEx,0,addr MDIClientClass,0,WS_VISIBLE+WS_CHILD+WS_TILED,\
                rect.left,rect.top,rect.right,rect.bottom,hWnd,0,hInstance,addr ccs
    mov     hMDIClient,eax        
    ret    
CreateControls  endp

CreateImageList PROC

    local   hBmp:HBITMAP
    local   hBmpMask:HBITMAP
    
    invoke  ImageList_Create,30,30,ILC_COLOR16+ILC_MASK,NoToolbarBitmaps\
                    ,NoToolbarBitmaps+10
    mov     hIml,eax
    lea     esi,ToolbarBmpIdentifiers
    mov     ecx,NoToolbarBitmaps
    cld
loop_1:
    push    ecx
    lodsd
    push    eax
    invoke  LoadImage,hInstance,eax,IMAGE_BITMAP,30,30,0
    mov     hBmp,eax
    pop     eax
    inc     eax
    invoke  LoadImage,hInstance,eax,IMAGE_BITMAP,30,30,0
    mov     hBmpMask,eax
    invoke	ImageList_Add,hIml,hBmp,eax
    invoke  DeleteObject,hBmp
    invoke  DeleteObject,hBmpMask
    pop     ecx
    dec     ecx
    jcxz    end_loop_1
    jmp     loop_1
end_loop_1:
    ret

CreateImageList endp                    